EnableExplicit

IncludeFile "HCGenerator.pbf"

Define event, EventGadget, EventType, EventMenu, EventWindow, prglauf

Global klassenverz$, druckformat$ = "L"

OpenWindow_0()

; ---------------------------------- Canvasroutinen ----------------------------------------
Structure canvasitem
      img.i
      x.i
      y.i
      name.s
      width.i
      height.i
      alphatest.i
      elemtyp.s
      String_elemtext.s
      elemdicke.i
      elemschattx.i
      elemschatty.i
      elemradius.i
      elemschriftgroesse.i
      elemschrift.s
      elemfarbe.i
      elemgrundfarbe.i
      elemfett.b
      elemkursiv.b
      elemunterstrich.b
      elembildmittext.b
   EndStructure


Define isCurrentItem=#False
Define currentItemXOffset.i, currentItemYOffset.i
Define Event.i, x.i, y.i, drag.i, hole.i
Global NewList Images.canvasitem()
Global NewList SusListeF.s()              ;Schlerliste aus den Fotos eines Verzeichnisses erzeugt

Declare mapbewladen(EventType)
Declare ImagesToFelder()

UsePNGImageDecoder()

Enumeration 10
      #ImagePopup
EndEnumeration

Enumeration 10
      #RemoveImage
EndEnumeration

Enumeration #PB_Compiler_EnumerationValue
  #Font_99
EndEnumeration

LoadFont(#Font_99,"Sans", 7)  ;Schriftgre fr das Einfgen der Beschriftung in der Darstellung

#DATEI_REPORT = 1

Procedure Addliniewaagerecht (List Images.canvasitem())
    If AddElement(Images())
        Images()\elemtyp = "W"
        Images()\img    = 0
        Images()\x      = 20
        Images()\y      = 100
        Images()\width  = 100
        Images()\height = 1
        Images()\alphatest = 0
        images()\name = ""
        images()\elemdicke = 3
        images()\elemfarbe = 255
        images()\elemgrundfarbe = 0
        images()\elemschattx = 0
        images()\elemschatty = 0
        images()\elemradius = 0
        images()\elemschrift = ""
        images()\elemschriftgroesse = 0
        images()\elemfett = 0
        images()\elemkursiv = 0
        images()\elemunterstrich = 0
        images()\elembildmittext = 0
        images()\String_elemtext = ""
    EndIf
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    ImagesToFelder()
EndProcedure
   
   Procedure Addliniesenkrecht (List Images.canvasitem())
   If AddElement(Images())
            Images()\elemtyp = "S"
            Images()\img    = 0
            Images()\x      = 20
            Images()\y      = 100
            Images()\width  = 1
            Images()\height = 100
            Images()\alphatest = 0
            images()\name = ""
            images()\elemdicke = 3
            images()\elemfarbe = 255
            images()\elemgrundfarbe = 0
            images()\elemschattx = 0
            images()\elemschatty = 0
            images()\elemradius = 0
            images()\elemschrift = ""
            images()\elemschriftgroesse = 0
            images()\elemfett = 0
            images()\elemkursiv = 0
            images()\elemunterstrich = 0
            images()\elembildmittext = 0
             images()\String_elemtext = ""
           EndIf   
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    ImagesToFelder()
   EndProcedure
   
    Procedure AddFlaeche (List Images.canvasitem())
   If AddElement(Images())
            Images()\elemtyp = "F"
            Images()\img    = 0
            Images()\x      = 20
            Images()\y      = 100
            Images()\width  = 100
            Images()\height = 100
            Images()\alphatest = 0
            images()\name = ""
            images()\elemdicke = 1
            images()\elemfarbe = 255
            images()\elemgrundfarbe = 0
            images()\elemschattx = 0
            images()\elemschatty = 0
            images()\elemradius = 0
            images()\elemschrift = ""
            images()\elemschriftgroesse = 0
            images()\elemfett = 0
            images()\elemkursiv = 0
            images()\elemunterstrich = 0
            images()\elembildmittext = 0
             images()\String_elemtext = ""
           EndIf
     AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    ImagesToFelder()
   EndProcedure
  
    Procedure Addtext (List Images.canvasitem())
   If AddElement(Images())
            Images()\elemtyp = "T"
            Images()\img    = 0
            Images()\x      = 20
            Images()\y      = 100
            Images()\width  = 6
            Images()\height = 6
            Images()\alphatest = 0
            images()\name = ""
            images()\elemdicke = 1
            images()\elemfarbe = 255
            images()\elemgrundfarbe = 0
            images()\elemschattx = 0
            images()\elemschatty = 0
            images()\elemradius = 0
            images()\elemschrift = "arial"
            images()\elemschriftgroesse = 16
            images()\elemfett = 0
            images()\elemkursiv = 0
            images()\elemunterstrich = 0
            images()\elembildmittext = 0
             images()\String_elemtext = "Beispieltext"
           EndIf
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    ImagesToFelder()
   EndProcedure

Procedure AddImage (name.s, List Images.canvasitem(), x, y, img, alphatest=0)
      If AddElement(Images())
         images()\elemtyp = "B"
            Images()\img    = img
            Images()\x      = x
            Images()\y      = y
            Images()\width  = ImageWidth(img)
            Images()\height = ImageHeight(img)
            Images()\alphatest = alphatest
            images()\name = name
            images()\elemdicke = 0
            images()\elemfarbe = 0
            images()\elemgrundfarbe = 0
            images()\elemschattx = 0
            images()\elemschatty = 0
            images()\elemradius = 0
            images()\elemschrift = "Sans"
            images()\elemschriftgroesse = 10
            images()\elemfett = 0
            images()\elemkursiv = 0
            images()\elemunterstrich = 0
            images()\elembildmittext = 1
             images()\String_elemtext = ""
           EndIf
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    ImagesToFelder()
EndProcedure

   Procedure AddRechteck (List Images.canvasitem())
   If AddElement(Images())
            Images()\elemtyp = "R"
            Images()\img    = 0
            Images()\x      = 20
            Images()\y      = 100
            Images()\width  = 50
            Images()\height = 50
            Images()\alphatest = 0
            images()\name = ""
            images()\elemdicke = 3
            images()\elemfarbe = 255
            images()\elemgrundfarbe = 0
            images()\elemschattx = 0
            images()\elemschatty = 0
            images()\elemradius = 0
            images()\elemschrift = ""
            images()\elemschriftgroesse = 0
            images()\elemfett = 0
            images()\elemkursiv = 0
            images()\elemunterstrich = 0
            images()\elembildmittext = 0
             images()\String_elemtext = ""
           EndIf
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)              
    ImagesToFelder()      
   EndProcedure

   Procedure DrawCanvas (canvas.i, List Images.canvasitem())
      Define innenwidth, innenheight, innenx, inneny, ypos, xpos, i, fontzusatz
      If StartDrawing(CanvasOutput(canvas))
         Box(0, 0, GadgetWidth(canvas), GadgetHeight(canvas), RGB(255,255,255))
       ;     DrawingMode(#PB_2DDrawing_AlphaBlend)
         DrawingMode(#PB_2DDrawing_Default)
         ForEach Images()
            Select images()\elemtyp
               Case "B"
                  DrawImage(ImageID(Images()\img),Images()\x,Images()\y,(Images()\width)/1.6,(Images()\height)/1.6) ; draw all images with z-order
  ;                DrawingFont(FontID(#Font_99))
                  If images()\elembildmittext = 1
                fontzusatz = 0                
                  If images()\elemfett = 1
                     fontzusatz = #PB_Font_Bold
                  EndIf                  
                  If images()\elemkursiv = 1
                     fontzusatz = fontzusatz +#PB_Font_Italic
                  EndIf                  
                  If images()\elemunterstrich = 1
                     fontzusatz = fontzusatz + #PB_Font_Underline
                  EndIf                 
                  LoadFont(11, images()\elemschrift, images()\elemschriftgroesse/2.0,fontzusatz)
                  
                  DrawingFont(FontID(11))
                     
                     DrawText(Images()\x,Images()\y+images()\height/1.6,Left(images()\name,Len(images()\name)-4),RGB(0,0,0),RGB(255,255,255))     
                  EndIf
                  
               Case "T"
                 ;  LoadFont(1, "Arial", 24)
                 ;  SetGadgetFont(#PB_Default, FontID(1))
                 fontzusatz = 0                
                  If images()\elemfett = 1
                     fontzusatz = #PB_Font_Bold
                  EndIf                  
                  If images()\elemkursiv = 1
                     fontzusatz = fontzusatz +#PB_Font_Italic
                  EndIf                  
                  If images()\elemunterstrich = 1
                     fontzusatz = fontzusatz + #PB_Font_Underline
                  EndIf                 
                  LoadFont(11, images()\elemschrift, images()\elemschriftgroesse/2.0,fontzusatz)
                  
                  DrawingFont(FontID(11))
                  DrawText(Images()\x,Images()\y,images()\String_elemtext,images()\elemfarbe,images()\elemgrundfarbe)     
                  Box(images()\x-3,images()\y-3,images()\width,images()\height,images()\elemfarbe)   
                  
               Case "W"
                  ypos = images()\y - (images()\elemdicke /2)
                  images()\height = images()\elemdicke
                  Box(images()\x,ypos,images()\width,images()\height,images()\elemfarbe) 
                   
               Case "R"
                  Line(images()\x,images()\y,images()\width,1,images()\elemfarbe)   
                  Line(images()\x,images()\y,1,images()\height,images()\elemfarbe)   
                  Line(images()\x,images()\y+images()\height,images()\width,1,images()\elemfarbe)   
                  Line(images()\x+images()\width,images()\y,1,images()\height,images()\elemfarbe)   
                  
               Case "S"
                  xpos = images()\x - (images()\elemdicke /2)
                  images()\width = images()\elemdicke
                  Box(xpos,images()\y,images()\width,images()\height,images()\elemfarbe) 
                  
               Case "F"
                  RoundBox(images()\x,images()\y,images()\width,images()\height,images()\elemradius,images()\elemradius,images()\elemfarbe) 
                  innenwidth = images()\width - (2* images()\elemdicke)
                  innenheight = images()\height - (2 * images()\elemdicke)
                  innenx = images()\x + images()\elemdicke
                  inneny = images()\y + images()\elemdicke
                  RoundBox(innenx, inneny,innenwidth,innenheight,images()\elemradius,images()\elemradius,images()\elemgrundfarbe) 
                  
            EndSelect      
         Next
         StopDrawing()
      EndIf
   EndProcedure

Procedure.i HitTest (List Images.canvasitem(), x, y)
      Shared currentItemXOffset.i, currentItemYOffset.i
      Protected alpha.i, isCurrentItem.i = #False
      
      If LastElement(Images()) ; search for hit, starting from end (z-order)
            Repeat
                  If x >= Images()\x And x < Images()\x + Images()\width
                        If y >= Images()\y And y < Images()\y + Images()\height
                              alpha = 255
                              If Images()\alphatest And ImageDepth(Images()\img)>31
                                    If StartDrawing(ImageOutput(Images()\img))
                                          DrawingMode(#PB_2DDrawing_AlphaChannel)
                                          alpha = Alpha(Point(x-Images()\x,y-Images()\y)) ; get alpha
                                          StopDrawing()
                                    EndIf
                              EndIf
                              If alpha
                                    MoveElement(Images(), #PB_List_Last)
                                    isCurrentItem = #True
                                    currentItemXOffset = x - Images()\x
                                    currentItemYOffset = y - Images()\y
                                    Break
                              EndIf
                        EndIf
                  EndIf
            Until PreviousElement(Images()) = 0
      EndIf
      
      ProcedureReturn isCurrentItem
    EndProcedure
    
    Procedure ImagesToFelder()
        If ListSize(images()) > 0
   SetGadgetText(String_elemtyp,images()\elemtyp)
;      img.i
SetGadgetText(String_elemxpos,Str(images()\x))
SetGadgetText(String_elemypos,Str(images()\y))
SetGadgetText(String_elemname,images()\name)
SetGadgetText(String_elembreite,Str(images()\width))
SetGadgetText(String_elemhoehe,Str(images()\height))
SetGadgetText(String_elemtext,images()\String_elemtext)
SetGadgetText(String_elemdicke,Str(images()\elemdicke))

SetGadgetText(String_elemschattx,Str(images()\elemschattx))
SetGadgetText(String_elemschatty,Str(images()\elemschatty))

SetGadgetText(String_elemradius,Str(images()\elemradius))
SetGadgetText(String_elemschriftgroese,Str(images()\elemschriftgroesse))
SetGadgetText(String_elemschrift,images()\elemschrift)

;      alphatest.i

SetGadgetColor(String_elemfarbe,#PB_Gadget_BackColor,images()\elemfarbe)
SetGadgetColor(String_elemgrundfarbe,#PB_Gadget_BackColor,images()\elemgrundfarbe)

      If images()\elemfett= 1
         SetGadgetState(Checkbox_elemfett,#True)
      Else
          SetGadgetState(Checkbox_elemfett,#False)       
      EndIf    
         
     If images()\elemkursiv= 1
         SetGadgetState(Checkbox_elemkursiv,#True)
      Else
          SetGadgetState(Checkbox_elemkursiv,#False)       
      EndIf    
        
     If images()\elemunterstrich= 1
         SetGadgetState(Checkbox_elemunterstrich,#True)
      Else
          SetGadgetState(Checkbox_elemunterstrich,#False)       
      EndIf    
        
     If images()\elembildmittext= 1
         SetGadgetState(Checkbox_elembildmittext,#True)
      Else
          SetGadgetState(Checkbox_elembildmittext,#False)       
      EndIf    
   EndIf 
EndProcedure   

Procedure FelderToImages(EventType)
   ;      img.i
   images()\x = Val(GetGadgetText(String_elemxpos))
   images()\y = Val(GetGadgetText(String_elemypos))
   images()\name = GetGadgetText(String_elemname)
   images()\width = Val(GetGadgetText(String_elembreite))
images()\height = Val(GetGadgetText(String_elemhoehe))
images()\String_elemtext = GetGadgetText(String_elemtext)
images()\elemdicke = Val(GetGadgetText(String_elemdicke))
images()\elemschattx = Val(GetGadgetText(String_elemschattx))
images()\elemschatty = Val(GetGadgetText(String_elemschatty))
images()\elemradius = Val(GetGadgetText(String_elemradius))
images()\elemschriftgroesse = Val(GetGadgetText(String_elemschriftgroese))
images()\elemschrift = GetGadgetText(String_elemschrift)
images()\elemfarbe = GetGadgetColor(String_elemfarbe,#PB_Gadget_BackColor)
images()\elemgrundfarbe = GetGadgetColor(String_elemgrundfarbe,#PB_Gadget_BackColor)


;      alphatest.i

If GetGadgetState(Checkbox_elemfett) = #True
   images()\elemfett = 1
Else
   images()\elemfett = 0
   EndIf
   
If GetGadgetState(Checkbox_elemkursiv) = #True
   images()\elemkursiv = 1
Else
   images()\elemkursiv = 0
   EndIf
   
If GetGadgetState(Checkbox_elemunterstrich) = #True
   images()\elemunterstrich = 1
Else
   images()\elemunterstrich = 0
   EndIf
   
If GetGadgetState(Checkbox_elembildmittext) = #True
   images()\elembildmittext = 1
Else
   images()\elembildmittext = 0
   EndIf
       
EndProcedure   


DrawCanvas(Canvas_0, Images())

CreatePopupMenu(#ImagePopup)
MenuItem(#RemoveImage,"Remove")

klassenverz$ = GetCurrentDirectory()
SetGadgetText(text_0,klassenverz$)

Fotoimport(EventType)

; ----- hier etwas das sofort beim Start erledigt werden soll eintragen

Repeat
      Event = WaitWindowEvent()
      EventGadget = EventGadget()
      EventType = EventType()
      EventMenu = EventMenu()
      EventWindow = EventWindow()
      
      If Event = #PB_Event_Gadget And EventGadget() = Canvas_0           ; ----------------- canvas sitzplan routinen ---------
            Select EventType()
                  Case #PB_EventType_LeftButtonDown
                        x = GetGadgetAttribute(Canvas_0, #PB_Canvas_MouseX)
                        y = GetGadgetAttribute(Canvas_0, #PB_Canvas_MouseY)
                        isCurrentItem = HitTest(Images(), x, y)
                        If isCurrentItem
                           DrawCanvas(Canvas_0, Images())
                           ImagesToFelder()
                        EndIf
                        Drag = #True
                  Case #PB_EventType_LeftButtonUp
                        Drag = #False
                  Case #PB_EventType_MouseMove
                        If Drag = #True
                              If isCurrentItem
                                    x = GetGadgetAttribute(Canvas_0, #PB_Canvas_MouseX)
                                    y = GetGadgetAttribute(Canvas_0,#PB_Canvas_MouseY)
                                    If LastElement(Images())
                                          Images()\x = x - currentItemXOffset
                                          Images()\y = y - currentItemYOffset
                                          DrawCanvas(Canvas_0, Images())
                           ImagesToFelder()
                                    EndIf
                              EndIf
                        EndIf
                        
                  Case #PB_EventType_RightButtonUp
                        x = GetGadgetAttribute(Canvas_0, #PB_Canvas_MouseX)
                        y = GetGadgetAttribute(Canvas_0, #PB_Canvas_MouseY)
                        isCurrentItem = HitTest(Images(), x, y)
                        If isCurrentItem
                           DrawCanvas(Canvas_0, Images())
                           imagestofelder()
                              DisplayPopupMenu(#ImagePopup,WindowID(Window_0))
                         EndIf           
                        
            EndSelect
      ElseIf Event = #PB_Event_Menu
            Select EventMenu()
                  Case #RemoveImage
                        If LastElement(Images())
                              DeleteElement(Images())
                              DrawCanvas(Canvas_0, Images())
                                   ClearGadgetItems(Combo_elemente)
    ForEach Images()
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    Next               
    ImagesToFelder()

                        EndIf
            EndSelect
            
      EndIf                  ; -------------------------- Canvas Sitzplan routinen 
      
      prglauf=Window_0_Events(Event)
Until prglauf=#False
End

; -------- ab hier die Proceduren fr Buttons, etc. -----------------

Procedure speichern(EventType)
  Define StandardFile$, Pattern$, Pattern, File$

  StandardFile$ = klassenverz$ + "Formular.txt"   ; anfnglichen Pfad + Dateiname festlegen
  ; Mit dem nchsten String werden die Pattern (mit "|" als Trennzeichen) fr anzuzeigende
  ; Dateitypen festgelegt:
  ;  Erster:  "Text (*.txt)" als Name, ".txt" und ".bat" als erlaubte Dateiendungen
  ;  Zweiter: "PureBasic (*.pb)" als Name, ".pb" al erlaubte Dateiendung
  ;  Dritter: "Alle Dateien (*.*) als Name, "*.*" als erlaubte Dateiendung, gltig fr alle Dateien
  Pattern$ = "Text (*.txt)|*.txt;*.bat|PureBasic (*.pb)|*.pb|Alle Dateien (*.*)|*.*"
  Pattern = 0    ; wir verwenden den ersten von drei mglichen Pattern als Standard
  File$ = SaveFileRequester("Bitte Datei zum Speichern auswhlen", StandardFile$, Pattern$, Pattern)
  If File$
      CreateFile(0,File$)
      ForEach images()
            WriteStringN(0,images()\elemtyp)
            WriteStringN(0,Str(images()\img))
            WriteStringN(0,Str(images()\x))
            WriteStringN(0,Str(images()\y))
            WriteStringN(0,Str(images()\width))
            WriteStringN(0,Str(images()\height))
            WriteStringN(0,Str(images()\alphatest))
            WriteStringN(0,images()\name)
            WriteStringN(0,Str(images()\elemdicke))
            
            WriteStringN(0,Str(images()\elemfarbe))
            WriteStringN(0,Str(images()\elemgrundfarbe))
            WriteStringN(0,Str(images()\elemschattx))
            WriteStringN(0,Str(images()\elemschatty))
           
            WriteStringN(0,Str(images()\elemradius))
            WriteStringN(0,images()\elemschrift)
           
            WriteStringN(0,Str(images()\elemschriftgroesse))
            WriteStringN(0,Str(images()\elemfett))
            WriteStringN(0,Str(images()\elemkursiv))
            WriteStringN(0,Str(images()\elemunterstrich))
            
            WriteStringN(0,Str(images()\elembildmittext))
            WriteStringN(0,images()\String_elemtext)
      Next
      CloseFile(0)
      
      ;MessageRequester("Information", "Sie haben folgende Datei ausgewhlt:"+Chr(10)+File$, 0)
  Else
    MessageRequester("Information", "Datei nicht gespeichert!", 0) 
  EndIf

EndProcedure

Procedure ansichtladen(EventType)
  Define StandardFile$, Pattern$, Pattern, File$
  
  ClearList(images())
  
StandardFile$ = klassenverz$ + "Formular.txt"   ; anfnglichen Pfad + Dateiname festlegen
  ; Mit dem nchsten String werden die Pattern (mit "|" als Trennzeichen) fr anzuzeigende
  ; Dateitypen festgelegt:
  ;  Erster:  "Text (*.txt)" als Name, ".txt" und ".bat" als erlaubte Dateiendungen
  ;  Zweiter: "PureBasic (*.pb)" als Name, ".pb" al erlaubte Dateiendung
  ;  Dritter: "Alle Dateien (*.*) als Name, "*.*" als erlaubte Dateiendung, gltig fr alle Dateien
  
  Pattern$ = "Text (*.txt)|*.txt;*.bat|Alle Dateien (*.*)|*.*"
  Pattern = 0    ; wir verwenden den ersten von drei mglichen Pattern als Standard
  File$ = OpenFileRequester("Bitte Datei zum Laden auswhlen", StandardFile$, Pattern$, Pattern)
  If File$
    
   If ReadFile(0, File$)   ; wenn die Datei geffnet werden konnte, setzen wir fort...
      While Eof(0) = 0           ; sich wiederholende Schleife bis das Ende der Datei ("end of file") erreicht ist
         
         If AddElement(Images())
            
            images()\elemtyp = ReadString(0)
            Images()\img    = Val(ReadString(0))
            Images()\x      = Val(ReadString(0))
            Images()\y      = Val(ReadString(0))
            Images()\width  = Val(ReadString(0))
            Images()\height = Val(ReadString(0))
            Images()\alphatest = Val(ReadString(0))
            images()\name = ReadString(0)
            images()\elemdicke = Val(ReadString(0))
            images()\elemfarbe = Val(ReadString(0))
            images()\elemgrundfarbe = Val(ReadString(0))
            images()\elemschattx = Val(ReadString(0))
            images()\elemschatty = Val(ReadString(0))
            images()\elemradius = Val(ReadString(0))
            images()\elemschrift = ReadString(0)
            images()\elemschriftgroesse = Val(ReadString(0))
            images()\elemfett = Val(ReadString(0))
            images()\elemkursiv = Val(ReadString(0))
            images()\elemunterstrich = Val(ReadString(0))
            images()\elembildmittext = Val(ReadString(0))
            images()\String_elemtext = ReadString(0)
            
            If images()\elemtyp = "B"
               images()\img = LoadImage(#PB_Any, klassenverz$ + images()\name)
            EndIf
         EndIf
         
      Wend
      CloseFile(0)               ; schlieen der zuvor geffneten Datei
      DrawCanvas(Canvas_0, Images())            
      ClearGadgetItems(Combo_elemente)
    ForEach Images()
    AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
    Next               
    ImagesToFelder()
  Else
      MessageRequester("Information","Konnte Datei nicht ffnen!")
    EndIf      
    
;    MessageRequester("Information", "Sie haben folgende Datei ausgewhlt:" + Chr(10) + File$, 0)
  Else
    MessageRequester("Information", "Keine Datei ausgewhlt!", 0) 
  EndIf
   
    
EndProcedure

Procedure Fotoimport(EventType)
     Define Type$, nurfoto$, wo
     
     ClearGadgetItems(listview_0)

     ClearList(SusListeF())
     If ExamineDirectory(0, klassenverz$, "*.png")  
          While NextDirectoryEntry(0)
               If DirectoryEntryType(0) = #PB_DirectoryEntry_File
                    Type$ = " [File] "
               Else
                    Type$ = " [Sub-Dir] "
               EndIf
               nurfoto$ = ReplaceString(DirectoryEntryName(0),".png","")
               AddGadgetItem(listview_0,0,nurfoto$)                 

               AddElement(SusListeF())
               nurfoto$ = ReverseString(nurfoto$)
               wo = FindString(nurfoto$," ")
               nurfoto$ = ReverseString(nurfoto$)
               nurfoto$ = Mid(nurfoto$,Len(nurfoto$)-wo+2,Len(nurfoto$))+ " " + Left(nurfoto$,Len(nurfoto$)-wo)
               ;     Debug nurfoto$                  
               SusListeF() = nurfoto$               
          Wend
          FinishDirectory(0)
     EndIf
     SortList(SusListeF(),#PB_Sort_NoCase)
EndProcedure

Procedure verzeichniswaehlen(EventType)
      klassenverz$ = PathRequester("Klassenverzeichnis",klassenverz$) 
      SetGadgetText(text_0,klassenverz$)

      Fotoimport(EventType)
      ansichtladen(EventType)
EndProcedure

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Linux
    #ZLIB_IMPORT_PATH = #PB_Compiler_Home + "purelibraries/linux/libraries/zlib.a"
    #drucklange = 900
    #druckbreite = 600
 ;   #drucklange = 870
  ;  #druckbreite = 615
 CompilerCase #PB_OS_Windows
    #ZLIB_IMPORT_PATH = "zlib.lib"
    #drucklange = 3525
    #druckbreite = 2475
  CompilerCase #PB_OS_MacOS
    #ZLIB_IMPORT_PATH = "/usr/lib/libz.dylib"
CompilerEndSelect

ImportC #ZLIB_IMPORT_PATH
  compress.l(*dest, *destlen, *source, sourcelen)
EndImport

; A4 8,2 x 11,6 inch (300dpi 2460 x 3480) (75dpi 615 x 870)
Procedure ansichtdrucken(EventType)
  Define link, susname$, BildID.i
  
  BildID.i=GetGadgetAttribute(Canvas_0,#PB_Canvas_Image)
  If PrintRequester()
    If StartPrinting("Sitzplan") ; Hier
      If StartDrawing(PrinterOutput())
        If druckformat$ = "P"     
          DrawImage(BildID,0,0)
   ;        DrawImage(BildID,0,0,#druckbreite,#drucklange)
       Else
          DrawImage(BildID,0,0)
   ;       DrawImage(BildID,0,0,#drucklange,#druckbreite)
       EndIf
        StopDrawing()
        StopPrinting()
      EndIf
    EndIf
  EndIf
  
EndProcedure

Procedure fotoeinfuegen(EventType)
    Define nurfoto$
    nurfoto$ = GetGadgetItemText( listview_0,GetGadgetState(listview_0))
    AddImage(nurfoto$ + ".png", Images(), 10, 10, LoadImage(#PB_Any, klassenverz$ + nurfoto$+".png"))
    DrawCanvas(Canvas_0, Images())
EndProcedure

Procedure ansloeschen(EventType)
    ClearGadgetItems(Combo_elemente)
    ClearList(images())
    DrawCanvas(Canvas_0, Images())            
EndProcedure

Procedure hoch(EventType)
    ResizeGadget(Canvas_0,1,1,492,696)
    druckformat$ = "P"
EndProcedure

Procedure quer(EventType)
    ResizeGadget(Canvas_0,1,1,696,492)
    druckformat$ = "L"
EndProcedure

Procedure.s PbFarbeToHtml (pbfarbe)
   Define farbe, rot, gruen, blau, result$
                  rot = Red(pbfarbe)
               gruen = Green(pbfarbe)
               blau = Blue(pbfarbe)
               farbe = blau + gruen * 256 + rot * 256 * 256 
               result$ = RSet(Hex(farbe), 6, "0")
               ProcedureReturn result$
   EndProcedure
   
Procedure htmlanzeigen(EventType)
   Define xpos, ypos, susname.s, breite, farbstr.s, hoehe, grundfarbstr.s, xpos2, ypos2,hilfpos, bemtext$
   Define fettstr$, unterlinestr$, kursiv$, schattenstr$
   
   If CreateFile(#DATEI_REPORT, klassenverz$ + "Formular.html") 
      WriteStringN(#DATEI_REPORT,"<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01//EN'>")
      WriteStringN(#DATEI_REPORT,"<!<html><head><title>Formular-erzeugt-mit-HCGenerator</title>")
      WriteStringN(#DATEI_REPORT,"<!</head><body>")
      ;     WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:10px; top: 8px; '>" + klassenverz$ + " erzeugt mit SuS2013</div>")
      
      ForEach  images()
         Select images()\elemtyp
               
            Case "B"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = images()\width
               hoehe = images()\height
          ;     WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px'  > <img src='"  + images()\name + "'> </div>")
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; width: " + breite + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px 5px black;'> <img src='"  + images()\name + "'> </div>")
               
               
               If images()\elembildmittext = 1
                  ypos = ypos +images()\height + 10
                  susname = Left(images()\name,Len(images()\name)-4)
               farbstr = PbFarbeToHtml(images()\elemfarbe)
                  WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; color:#"+farbstr+"; font-size:"+images()\elemschriftgroesse +"px;'>" + susname + "</div>")
               EndIf
               
            Case "W"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = (images()\width) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 
      
            Case "S"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 
      
            Case "F"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               grundfarbstr = PbFarbeToHtml(images()\elemgrundfarbe)
      WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; height:"+images()\height+"px; width:"+images()\width+"px; background-color:#"+grundfarbstr +"; box-shadow:"+ images()\elemschattx +"px " + images()\elemschatty +"px "+images()\elemschattx +"px black; border-radius: "+images()\elemradius+"px;border:" +images()\elemdicke +"px solid #" + farbstr +"; padding:10px;'></div>")

      
            Case "R"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               breite = (images()\width) * 1.55
               xpos2 = xpos + breite
               ypos2 = ypos + hoehe
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               grundfarbstr = PbFarbeToHtml(images()\elemgrundfarbe)
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 
               hilfpos = ypos+images()\elemdicke
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px;top:" + hilfpos + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 
               WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px;top:" + ypos2 + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 
               hilfpos = hoehe+images()\elemdicke
              WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos2 + "px;top:" + ypos + "px; height: " + hilfpos + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>") 

             Case "T"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = (images()\width) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               bemtext$ = images()\String_elemtext
               fettstr$ = ""
               unterlinestr$ = ""
               kursiv$ = ""
               schattenstr$ = ""
               If images()\elemfett = #True
                  fettstr$ = "font-weight:bold;"
               EndIf
               
               If images()\elemunterstrich = #True
                  unterlinestr$ = "text-decoration:underline;"
               EndIf
               
               If images()\elemkursiv = #True
                  kursiv$ = "font-style:italic;"
               EndIf
               
               If images()\elemschattx > 0 Or images()\elemschatty > 0
                  schattenstr$ = "text-shadow:black "+images()\elemschattx+"px "+images()\elemschatty+"px 4px;"
               EndIf   
      WriteStringN(#DATEI_REPORT,"<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; color:#"+farbstr+";"+unterlinestr$ + fettstr$ + kursiv$ + schattenstr$ +"font-family:"+images()\elemschrift+"; font-size:"+images()\elemschriftgroesse +"px;'>" + bemtext$ + "</div>")
              
         EndSelect   
      Next
      WriteStringN(#DATEI_REPORT,"</body></html>")        
      CloseFile(#DATEI_REPORT)
   EndIf
   
   CompilerSelect #PB_Compiler_OS
      CompilerCase #PB_OS_Linux
         RunProgram("defaultbrowser", klassenverz$ + "Formular.html","")
      CompilerCase #PB_OS_Windows
         RunProgram(klassenverz$ + "Formular.html")
      CompilerCase #PB_OS_MacOS
         
   CompilerEndSelect    
EndProcedure

Procedure grundfarbedialog(EventType)
   Define farbe, a$
   
   Farbe = ColorRequester()
   If Farbe > -1
;      a$ = "Sie haben folgende Farbwerte ausgewhlt:" + Chr(10)  ; Chr(10) wird nur
 ;     a$ + "24 Bit Wert: " + Str(Farbe)               + Chr(10)  ; fr den Zeilen-
  ;    a$ + "Rot-Wert:    " + Str(Red(Farbe))          + Chr(10)  ; umbruch bentigt
   ;   a$ + "Grn-Wert:  " + Str(Green(Farbe))         + Chr(10)
    ;  a$ + "Blau-Wert:   " + Str(Blue(Farbe))
     ; MessageRequester("Information", a$, 0)
      SetGadgetColor(String_elemgrundfarbe,#PB_Gadget_BackColor,farbe)
   EndIf
EndProcedure
  
Procedure farbdialog(EventType)
   Define farbe
   
   Farbe = ColorRequester()
   If Farbe > -1
       SetGadgetColor(String_elemfarbe,#PB_Gadget_BackColor,farbe)
   EndIf
EndProcedure

Procedure liniewaagerecht(EventType)
    AddLiniewaagerecht(Images())
    DrawCanvas(Canvas_0, Images())
EndProcedure
 
Procedure liniesenkrecht(EventType)
     AddLiniesenkrecht(Images())
    DrawCanvas(Canvas_0, Images())
EndProcedure
 
Procedure rechteck(EventType)
     Addrechteck(Images())
    DrawCanvas(Canvas_0, Images())
EndProcedure
 
Procedure texteinf(EventType)
      Addtext(Images())
    DrawCanvas(Canvas_0, Images())
EndProcedure
 
Procedure Flaeche(EventType)
      AddFlaeche(Images())
    DrawCanvas(Canvas_0, Images())
EndProcedure
 
Procedure savechange(EventType)
  FelderToImages(EventType)
  DrawCanvas(Canvas_0, Images())  
 ; ClearGadgetItems(Combo_elemente)
  ;ForEach images()
   ;   AddGadgetItem(Combo_elemente,-1,images()\elemtyp)
  ;  Next  
EndProcedure
 
Procedure schriftdialog(EventType)
   Define FontName$, fontsize, result, Message$
  FontName$ = "Arial"   ; Anfangs-Zeichensatz festlegen  (Kann auch ein leer sein)
  FontSize  = 14        ; Anfangs-Gre festlegen  (kann auch Null sein)
  Result = FontRequester(FontName$, FontSize, #PB_FontRequester_Effects)
  If Result
;    Message$ = "Sie haben folgenden Zeichensatz ausgewhlt:"  + #LF$ 
 ;   Message$ + "Name:  " + SelectedFontName()       + #LF$
  ;  Message$ + "Gre: " + Str(SelectedFontSize())  + #LF$
   ; Message$ + "Farbe: " + Str(SelectedFontColor()) + #LF$
    
    SetGadgetState(Checkbox_elemfett,#False)
    SetGadgetState(Checkbox_elemunterstrich,#False)
    SetGadgetState(Checkbox_elemkursiv,#False)
    
    If SelectedFontStyle() & #PB_Font_Bold
;       Message$ + "Fett" + #LF$
       SetGadgetState(Checkbox_elemfett,#True)
    EndIf
    If SelectedFontStyle() & #PB_Font_Italic
;      Message$ + "Durchgestrichen" + #LF$
       SetGadgetState(Checkbox_elemkursiv,#True)
    EndIf
    If SelectedFontStyle() & #PB_Font_Underline
;      Message$ + "Unterstrichen" + #LF$
       SetGadgetState(Checkbox_elemunterstrich,#True)
    EndIf
  Else 
;    Message$ = "Der Requester wurde abgebrochen."
  EndIf
  
;  MessageRequester("FontRequester", Message$, #PB_MessageRequester_Ok) 
  SetGadgetText(String_elemschrift,SelectedFontName())
  SetGadgetText(String_elemschriftgroese,Str(SelectedFontSize()))
EndProcedure

Procedure elementwahl(EventType)
  Define elementnr, i
  
  elementnr = GetGadgetState(Combo_elemente)
  FirstElement(images())
  For i = 0 To elementnr
     NextElement(images())
   Next
   PreviousElement(images())
   ImagesToFelder()
EndProcedure

Procedure pbhtmlerzeugen(EventType)
     Define xpos, ypos, susname.s, breite, farbstr.s, hoehe, grundfarbstr.s, xpos2, ypos2,hilfpos, bemtext$
   Define fettstr$, unterlinestr$, kursiv$, schattenstr$
   
   If CreateFile(#DATEI_REPORT, klassenverz$ + "PBFormular.txt") 
      WriteStringN(#DATEI_REPORT,"Procedure htmlanzeigen(EventType)")  
 ;  WriteStringN(#DATEI_REPORT,"Define xpos, ypos, susname.s, breite, farbstr.s, hoehe, grundfarbstr.s, xpos2, ypos2,hilfpos, bemtext$")
  ; WriteStringN(#DATEI_REPORT,"Define fettstr$, unterlinestr$, kursiv$, schattenstr$")
   
  ; WriteStringN(#DATEI_REPORT,"If CreateFile(#DATEI_REPORT, Verzeichnis$ + " + Chr(34) + "TestFormular.html" + Chr(34) +")") 
   WriteStringN(#DATEI_REPORT,"If CreateFile(#DATEI_REPORT,  " + Chr(34) + "TestFormular.html" + Chr(34) +")") 
   
   WriteStringN(#DATEI_REPORT,"WriteStringN(#DATEI_REPORT," + Chr(34) + "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01//EN'>"+ Chr(34) + ")")
   WriteStringN(#DATEI_REPORT,"WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<!<html><head><title>Formular-mit-HCGenerator-erzeugt</title>"+ Chr(34) + ")")
   WriteStringN(#DATEI_REPORT,"WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<!</head><body>"+ Chr(34) + ")")
   ; -------------------------------------------------------------------------------------
      
    ForEach  images()
         Select images()\elemtyp
               
            Case "B"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = images()\width
               hoehe = images()\height
                 WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT," + Chr(34) + "<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; width: " + breite + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px 5px black;'> <img src='"  + images()\name + "'> </div>" + Chr(34) + ")")
               
               
               If images()\elembildmittext = 1
                  ypos = ypos +images()\height + 10
                  susname = Left(images()\name,Len(images()\name)-4)
               farbstr = PbFarbeToHtml(images()\elemfarbe)
                   WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; color:#"+farbstr+"; font-size:"+images()\elemschriftgroesse +"px;'>" + susname + "</div>" + Chr(34) + ")")
               EndIf
               
            Case "W"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = (images()\width) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
                WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")
      
            Case "S"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
                WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")
      
            Case "F"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               grundfarbstr = PbFarbeToHtml(images()\elemgrundfarbe)
              WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; height:"+images()\height+"px; width:"+images()\width+"px; background-color:#"+grundfarbstr +"; box-shadow:"+ images()\elemschattx +"px " + images()\elemschatty +"px "+images()\elemschattx +"px black; border-radius: "+images()\elemradius+"px;border:" +images()\elemdicke +"px solid #" + farbstr +"; padding:10px;'></div>" + Chr(34) + ")")

      
            Case "R"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               hoehe = (images()\height) * 1.55
               breite = (images()\width) * 1.55
               xpos2 = xpos + breite
               ypos2 = ypos + hoehe
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               grundfarbstr = PbFarbeToHtml(images()\elemgrundfarbe)
                WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px;top:" + ypos + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")
               hilfpos = ypos+images()\elemdicke
                WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px;top:" + hilfpos + "px; height: " + hoehe + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")
                WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos + "px;top:" + ypos2 + "px; width: " + breite + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-top:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")
               hilfpos = hoehe+images()\elemdicke
               WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT,"+ Chr(34) + "<div style='position:absolute; left:" + xpos2 + "px;top:" + ypos + "px; height: " + hilfpos + "px; box-shadow:" + images()\elemschattx + "px " + images()\elemschatty +"px " +images()\elemschattx +"px black; border-left:" + images()\elemdicke + "px solid #" + farbstr + "'></div>" + Chr(34) + ")")

             Case "T"
               xpos = (images()\x)*1.6
               ypos = (images()\y)*1.6
               breite = (images()\width) * 1.55
               farbstr = PbFarbeToHtml(images()\elemfarbe)
               bemtext$ = images()\String_elemtext
               fettstr$ = ""
               unterlinestr$ = ""
               kursiv$ = ""
               schattenstr$ = ""
               If images()\elemfett = #True
                  fettstr$ = "font-weight:bold;"
               EndIf
               
               If images()\elemunterstrich = #True
                  unterlinestr$ = "text-decoration:underline;"
               EndIf
               
               If images()\elemkursiv = #True
                  kursiv$ = "font-style:italic;"
               EndIf
               
               If images()\elemschattx > 0 Or images()\elemschatty > 0
                  schattenstr$ = "text-shadow:black "+images()\elemschattx+"px "+images()\elemschatty+"px 4px;"
               EndIf   
       WriteStringN(#DATEI_REPORT,"    WriteStringN(#DATEI_REPORT," + Chr(34) + "<div style='position:absolute; left:" + xpos + "px; top:" + ypos + "px; color:#"+farbstr+";"+unterlinestr$ + fettstr$ + kursiv$ + schattenstr$ +"font-family:"+images()\elemschrift+"; font-size:"+images()\elemschriftgroesse +"px;'>" + bemtext$ + "</div>" + Chr(34) + ")")
              
         EndSelect   
      Next
    ;  ------------------------------------------------------------------------------------    
     WriteStringN(#DATEI_REPORT,"WriteStringN(#DATEI_REPORT,"+ Chr(34) + "</body></html>" + Chr(34) + ")")        
      WriteStringN(#DATEI_REPORT,"CloseFile(#DATEI_REPORT)")
      WriteStringN(#DATEI_REPORT,"EndIf")
      
        WriteStringN(#DATEI_REPORT,"CompilerSelect #PB_Compiler_OS")
      WriteStringN(#DATEI_REPORT,"CompilerCase #PB_OS_Linux")
         WriteStringN(#DATEI_REPORT,"RunProgram("+Chr(34) + "defaultbrowser"+Chr(34) + ", "+ Chr(34) + "TestFormular.html"+Chr(34) + ","+Chr(34)+Chr(34)+ ")")
      WriteStringN(#DATEI_REPORT,"CompilerCase #PB_OS_Windows")
         WriteStringN(#DATEI_REPORT,"RunProgram(" + Chr(34) + "TestFormular.html" + Chr(34) + ")")
      WriteStringN(#DATEI_REPORT,"CompilerCase #PB_OS_MacOS")
         
   WriteStringN(#DATEI_REPORT,"CompilerEndSelect ")       
     WriteStringN(#DATEI_REPORT,"EndProcedure")
     CloseFile(#DATEI_REPORT)
     EndIf
  EndProcedure
  
  
; IDE Options = PureBasic 5.11 (Windows - x86)
; CursorPosition = 995
; FirstLine = 965
; Folding = -----------------
; EnableThread
; EnableXP
; Executable = HCGenerator.exe
; DisableDebugger